﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using C1.Silverlight.DataGrid;
using C1.Silverlight.Data;
using System.Windows.Data;
using System.Collections.ObjectModel;

namespace C1DataGrid_Sample
{
    public partial class MainPage : UserControl
    {

        public MainPage()
        {
            InitializeComponent();
            ObservableCollection<Data> testData = new ObservableCollection<Data>();

            Data test;

            test = new Data() { Area = 23444, Continent = "North America", Country = "Canada" };
            testData.Add(test);
            test = new Data() { Area = 16344, Continent = "South America", Country = "Brazil" };
            testData.Add(test);
            test = new Data() { Area = 3244, Continent = "Europe", Country = "Italy" };
            testData.Add(test);
            test = new Data() { Area = 23562, Continent = "North America", Country = "USA" };
            testData.Add(test);
            test = new Data() { Area = 73423, Continent = "Asia", Country = "China" };
            testData.Add(test);
            test = new Data() { Area = 45724, Continent = "Asia", Country = "India" };
            testData.Add(test);
            test = new Data() { Area = 18457, Continent = "Asia", Country = "Japan" };
            testData.Add(test);
            test = new Data() { Area = 4721, Continent = "Europe", Country = "Spain" };
            testData.Add(test);
            test = new Data() { Area = 5724, Continent = "Asia", Country = "Malaysia" };
            testData.Add(test);
            test = new Data() { Area = 3444, Continent = "North America", Country = "Mexico" };
            testData.Add(test);
            test = new Data() { Area = 16344, Continent = "South America", Country = "Argentina" };
            testData.Add(test);
            test = new Data() { Area = 2457, Continent = "Asia", Country = "Vietnam" };
            testData.Add(test);
            test = new Data() { Area = 4721, Continent = "Europe", Country = "Austria" };
            testData.Add(test);
            test = new Data() { Area = 3244, Continent = "Europe", Country = "Netherlands" };
            testData.Add(test);
            test = new Data() { Area = 3562, Continent = "South America", Country = "Chile" };
            testData.Add(test);
            test = new Data() { Area = 3423, Continent = "Asia", Country = "Thailand" };
            testData.Add(test);
            test = new Data() { Area = 3562, Continent = "South America", Country = "Columbia" };
            testData.Add(test);
            test = new Data() { Area = 1423, Continent = "Asia", Country = "Taiwam" };
            testData.Add(test);
            test = new Data() { Area = 5724, Continent = "Asia", Country = "Indonesia" };
            testData.Add(test);
            test = new Data() { Area = 6344, Continent = "South America", Country = "Peru" };
            testData.Add(test);
            test = new Data() { Area = 2423, Continent = "Asia", Country = "Nepal" };
            testData.Add(test);
            test = new Data() { Area = 8724, Continent = "Asia", Country = "South Korea" };
            testData.Add(test);
            test = new Data() { Area = 6344, Continent = "South America", Country = "Venezuela" };
            testData.Add(test);

            grid.FilterChanged += new EventHandler<DataGridFilterChangedEventArgs>(grid_FilterChanged);
            grid.GroupChanged += new EventHandler<DataGridGroupChangedEventArgs>(grid_GroupChanged);
            grid.FilterChanging += new EventHandler<DataGridFilterChangingEventArgs>(grid_FilterChanging);
            grid.GroupChanging += new EventHandler<DataGridGroupChangingEventArgs>(grid_GroupChanging);
            grid.SortChanging += new EventHandler<DataGridSortChangingEventArgs>(grid_SortChanging);
            grid.SortChanged += new EventHandler<DataGridSortChangedEventArgs>(grid_SortChanged);

            grid.ItemsSource = testData;
        }

        int hashCode;

        public void SaveSelection()
        {
            if (grid.Selection.SelectedRows.Count > 0)
                hashCode = grid.SelectedItem.GetHashCode();
        }

        public void RetainSelection()
        {
            int flag = 0;

            if (hashCode != null)
            {
                for (int i = 0; i < grid.Rows.Count; i++)
                {
                    if (grid.Rows[i].DataItem.GetHashCode() == hashCode)
                    {
                        grid.Selection.Clear();
                        grid.Selection.Add(grid.Rows[i], grid.Rows[i]);
                        flag = 1;
                        break;
                    }
                    else
                    {
                        flag = 0;
                    }
                }

                if (flag == 0)
                {
                    grid.Selection.Clear();
                }
            }
        }

        void grid_SortChanging(object sender, DataGridSortChangingEventArgs e)
        {
            SaveSelection();
        }

        void grid_SortChanged(object sender, DataGridSortChangedEventArgs e)
        {
            RetainSelection();
        }

        void grid_GroupChanging(object sender, DataGridGroupChangingEventArgs e)
        {
            SaveSelection();
        }

        void grid_GroupChanged(object sender, DataGridGroupChangedEventArgs e)
        {
            RetainSelection();
        }

        void grid_FilterChanging(object sender, DataGridFilterChangingEventArgs e)
        {
            SaveSelection();
        }

        void grid_FilterChanged(object sender, DataGridFilterChangedEventArgs e)
        {
            RetainSelection();
        }

    }

    public class Data
    {
        public int Area { get; set; }
        public string Continent { get; set; }
        public string Country { get; set; }
    }
}
